CON
  _clkmode        = xtal1 + pll16x
  _xinfreq        = 5_000_000

VAR
  byte ReceivedByte
  byte RxResult
  word x
  word y
  word v
'the code for additional commands are stored in *.SPIN-files
'these files are called OBJECTS

OBJ
'in the OBJ-ect-section of a SPIN-code-file
'you have to make a connection between an objectname and a *.SPIN-file   
'objectname here is "Serial"

           'Filename of the code here "FullDuplexSerialPlus.SPIN"
           'this file contains the commands for serial communication

  Serial : "FullDuplexSerialPlus"   


PUB Demo
'before you can use the commands from the *.SPIN-file
'you have to call the Start-command of the object

  'Serial.Start(31,30,0,16468) 'custom baudrate of andy
  Serial.Start(31,30,0,115200)
  'explaining:
  '31: Rx-IO-Pin
  '30: Tx-IO-Pin
  ' 0: operation-mode usually 0
  '16468 baudrate

  Serial.Str( string("FullDuplexSerialDriver started",13,13))
  'waitcnt(ClkFreq + cnt)

  repeat
    RxResult := Receive
    if RxResult == 1
      Servo
    else
        
      Serial.Str( string("value of variable RxResult is "))
      Serial.Dec(RxResult)
      Serial.Tx(13) 'send one byte with value decimal 13=Carriage Return
      Serial.Str( string("Verifying NOT OK no call of subroutine servo",13,13,13))

      
Pub Receive : VerifyingIsOk
'VerifyingIsOk is the name of the resultvariable
'this means the command "Receive" will give back a value
'like f.e. a BS-command like "SQR"  a = SQR 100 (a will contain value 10)
'in SPIN you can define subroutines that will will give back a value
'f.e. PUB MySubroutine : MyReturnValue
'use of this subroutine b := MySubroutine
'this means after MySubRoutine has been executed variable "b" will contain a value which was set INSIDE
'of the subroutine MySubRoutine     

'BS2-command
'SERIN 0, 16468, [WAIT("!"), x.HIGHBYTE, x.LOWBYTE, y.HIGHBYTE, y.LOWBYTE, v.HIGHBYTE, v.LOWBYTE]

  Serial.Str( string("wait for char !",13))
  waitcnt(ClkFreq + cnt)

  ReceivedByte := 0           'initialise variable with zero
  'equivalent for WAIT("!")
  repeat until ReceivedByte == "!" 
    ReceivedByte := Serial.Rx 'receive bytes and wait for character "!"  

  Serial.Str( string("! received expect 6 bytes",13))

  ReceivedByte := Serial.Rx 'receive x-highbyte 
            Serial.Str( string("x-highbyte received value of byte:"))
            Serial.Dec(ReceivedByte)
            Serial.Tx(13)  'send one byte with value decimal 13=Carriage Return
  x := ReceivedByte * 256   'store highbyte into x


  ReceivedByte := Serial.Rx 'receive x-lowbyte 
            Serial.Str( string("x-lowbyte received value of byte:"))
            Serial.Dec(ReceivedByte)
            Serial.Tx(13)  '13: Carriage Return
  x := x + ReceivedByte     'store lowbyte into x
    

  ReceivedByte := Serial.Rx 'receive x-highbyte 
            Serial.Str( string("y-highbyte received value of byte:"))
            Serial.Dec(ReceivedByte)
            Serial.Tx(13)  '13: Carriage Return
  y := ReceivedByte * 256


  ReceivedByte := Serial.Rx 'receive x-lowbyte 
            Serial.Str( string("y-lowbyte received value of byte:"))
            Serial.Dec(ReceivedByte)
            Serial.Tx(13)  '13: Carriage Return
  y := y + ReceivedByte


  ReceivedByte := Serial.Rx 'receive x-highbyte 
            Serial.Str( string("v-highbyte received value of byte:"))
            Serial.Dec(ReceivedByte)
            Serial.Tx(13)  '13: Carriage Return
  v := ReceivedByte * 256

  ReceivedByte := Serial.Rx 'receive x-lowbyte 
            Serial.Str( string("v-lowbyte received value of byte:"))
            Serial.Dec(ReceivedByte)
            Serial.Tx(13)  '13: Carriage Return
  v := v + ReceivedByte

  x := (x / 4) - 623 'This is the code to scale down the x data from the tilt sensor.
  y := (y / 4) - 629 'This is the code to scale down the y data from the tilt sensor.

  if v == 66
    VerifyingIsOk := 1
  else
    VerifyingIsOk := 0


Pub Servo
'instead of creating pulses this subroutine just echoes back the received values

  Serial.Str( string("X ="))
  Serial.Dec(x)

  Serial.Str( string("  Y ="))
  Serial.Dec(y)

  Serial.Str( string("  V ="))
  Serial.Dec(v)

  Serial.Tx(13)  '13: Carriage Return
  Serial.Tx(13)  '13: Carriage Return
  

         